
local M = {}



local isBreakSquealEnabled = false
local brakeTable = {}



--============================================================CAMERA==============================================================
local function onUpdate(dt)
	if core_camera ~= nil and core_camera.isCameraInside(0, getCameraPosition()) ~= nil and be:getPlayerVehicle(0) ~= nil then
		if core_camera.isCameraInside(0, getCameraPosition()) == true then
			be:getPlayerVehicle(0):queueLuaCommand('if drivingSounds ~= nil then drivingSounds.cameraMode = (\"dash\") end ')
		else
			be:getPlayerVehicle(0):queueLuaCommand('if drivingSounds ~= nil then drivingSounds.cameraMode = (\"exterior\") end ')
		end
	end
end
--============================================================CAMERA==============================================================







--======================================================================WOOSH SOUND========================================================================
local function onVehicleSwitched(oldId, newId, player)	
		be:getPlayerVehicle(0):queueLuaCommand('if drivingSounds ~= nil then drivingSounds.onVehicleSwitched() end') -- Call onVehicleSwitched function
		be:getObjectByID(newId):queueLuaCommand('if drivingSounds ~= nil then drivingSounds.switch = (\"'..newId..'\") end') -- Tell to the new vehicle that it's focused then play first person sounds again
		if oldId ~= -1 then be:getObjectByID(oldId):queueLuaCommand('if drivingSounds ~= nil then drivingSounds.switch = (\"'..newId..'\") end ') end -- Tell to the old vehicle that is no longer focused then stop first person sounds
	
		brakeTable[oldId] = isBrakeSquealEnabled
		isBrakeSquealEnabled = brakeTable[newId]

		if isBrakeSquealEnabled == true then
			be:queueJS('if (document.getElementById("btBrakes") != null) {document.getElementById("btBrakes").textContent="B:1";}')
			be:getPlayerVehicle(0):queueLuaCommand('if vehicleSounds ~= nil then vehicleSounds.toggleBrakeSqueal(true) end')
		else
			be:queueJS('if (document.getElementById("btBrakes") != null) {document.getElementById("btBrakes").textContent="B:0";}')
			be:getPlayerVehicle(0):queueLuaCommand('if vehicleSounds ~= nil then vehicleSounds.toggleBrakeSqueal(false) end')
		end
end
--======================================================================WOOSH SOUND========================================================================







local function removeTableKey(tableValue, keyToRemove)
	local newTable = {}
	for k, v in pairs(tableValue) do
		if k ~= keyToRemove then
			newTable[k] = v
		end
	end
	return newTable
end







local function onVehicleSpawned(veh)
	be:getPlayerVehicle(0):queueLuaCommand("extensions.addModulePath('lua/vehicle/extensions/SAH')") -- Load lua files
	be:getPlayerVehicle(0):queueLuaCommand("extensions.loadModulesInDirectory('lua/vehicle/extensions/SAH')")
	brakeTable[veh] = false
end

local function onVehicleDestroyed(veh)
	brakeTable = removeTableKey(brakeTable, veh)
end







local function brakes(value)
	isBreakSquealEnabled = value
	if isBreakSquealEnabled == true then
		be:getPlayerVehicle(0):queueLuaCommand('if vehicleSounds ~= nil then vehicleSounds.toggleBrakeSqueal(true) end')
	else
		be:getPlayerVehicle(0):queueLuaCommand('if vehicleSounds ~= nil then vehicleSounds.toggleBrakeSqueal(false) end')
	end	
end




M.onVehicleDestroyed  = onVehicleDestroyed
M.brakes 			  = brakes
M.onCameraModeChanged = onCameraModeChanged
M.onVehicleSwitched   = onVehicleSwitched
M.onVehicleSpawned    = onVehicleSpawned
M.onUpdate 			  = onUpdate

return M