

--All content of this file come from jojos38, do not reupload anything without my permission !


local M = {}

local isSignalOn = false

--========================================================INITILIZATION==========================================================
local function onInit()
	if electrics.values.hazard_enabled == 1 then electrics.toggle_warn_signal() end -- Disable the hazard light on vehicle reset
	if electrics.values.signal_left_input == 1 then electrics.toggle_left_signal() end -- Same for left signal
	if electrics.values.signal_right_input == 1 then electrics.toggle_right_signal() end -- Same for right signal
end
--========================================================INITILIZATION==========================================================







--================================================================VALUES==================================================================
local handbrakeLock = 	obj:createSFXSource('art/sound/handbrakelock.ogg', 	 	 'AudioDefault3D', 		"handbrakeLock",	 v.data.refNodes[0].ref)
local handbrakeUnlock = obj:createSFXSource('art/sound/handbrakeunlock.ogg',	 'AudioDefault3D', 		"handbrakeUnlock"  , v.data.refNodes[0].ref)
local shift1 =    		obj:createSFXSource('art/sound/shift1.ogg',       		 'AudioDefault3D', 		"shift1", 			 v.data.refNodes[0].ref)
local shift2 =    		obj:createSFXSource('art/sound/shift2.ogg',       		 'AudioDefault3D', 		"shift2", 			 v.data.refNodes[0].ref)
local shift3 =    		obj:createSFXSource('art/sound/shift3.ogg',       		 'AudioDefault3D', 		"shift3", 			 v.data.refNodes[0].ref) 
local brake = 			obj:createSFXSource('art/sound/brake.ogg', 				 'AudioDefaultLoop3D',  "brake",			 v.data.refNodes[0].ref)
local rfan = 			obj:createSFXSource('art/sound/radiatorfan.ogg', 		 'AudioDefaultLoop3D',  "rfan",				 v.data.refNodes[0].ref)
--================================================================VALUES==================================================================







--=====================VALUES=======================
local fogMem
local gearMem
local lightsMem
local engineSoundPlayed = false
local brakeSoundSwitch  = false
local rand
local waterTempVolume = 0
local fanPitch = 0
local fanVolume = 0
local frictionDelay = 0
local soundRev = 0
local brakeFadeIn = 0
local brakeFadeOut = 1
local brakeDuration = 0
local isBrakeRand = false
local randBrake = 0
local isBrakeSquealEnabled = false
local nodesList = {}
local frictionVolume = 0
local frictionPitch = 0
--=====================VALUES=======================







local function onUpdate(dt) --ONUPDATE OPEN
	
	
	if drivingSounds.cameraMode == "dash" then --DASH OPEN
	
	
--============================================SHIFT SOUND============================================== (DASH)
		if gearMem ~= electrics.values.gearIndex then -- If the gear change
			rand = math.random(3) -- Randomly play one of the 3 sounds
			if rand == 1 then 
				obj:setVolume(shift1, 1)
				obj:playSFX(shift1)
			end
			if rand == 2 then 
				obj:setVolume(shift2, 1)
				obj:playSFX(shift2)
			end
			if rand == 3 then 
				obj:setVolume(shift3, 1)
				obj:playSFX(shift3)
			end
		end
		gearMem = electrics.values.gearIndex		
--============================================SHIFT SOUND============================================== (DASH)







--========================================HANDBRAKE BRAKE SOUND========================================== (DASH)
		if input.parkingbrake == 1 and brakeSoundSwitch == false then --If the handbrake is on 
			obj:setVolume(handbrakeLock, 2)
			obj:playSFX(handbrakeLock)
			brakeSoundSwitch = true -- To avoid sound playing more than 1 time
		elseif input.parkingbrake == 0 and brakeSoundSwitch == true then -- Else if the handbrake is off
			obj:setVolume(handbrakeUnlock, 2)
			obj:playSFX(handbrakeUnlock)
			brakeSoundSwitch = false -- To avoid sound playing more than 1 time
		end
--========================================HANDBRAKE BRAKE SOUND========================================== (DASH)	






	else
		isSignalOn = false --Prevent signal sound to be played on vehicle reset
		if input.parkingbrake == 1 then brakeSoundSwitch = true end --Prevent handbrake sound to be played on vehicle reset
		if input.parkingbrake == 0 then brakeSoundSwitch = false end
	end --DASH CLOSE
	



	
	
--================================================================RADIATOR FAN SOUND================================================================	
	if electrics.values.watertemp ~= nil and electrics.values.watertemp > 93 and electrics.values.rpm > 1 then 
		waterTempVolume = electrics.values.watertemp/90 -- Define the volume and the pitch of the fan
		
		if fanVolume < waterTempVolume then -- Fade in sound
			obj:setVolumePitch(rfan, fanVolume/2, fanPitch)
			fanVolume = fanVolume + 0.01 -- Increase fan volume slowly to have fade effect
			fanPitch = fanVolume -- Set fan pitch
			if fanPitch > 1.3 then fanPitch = 1.3 end -- Fan pitch max value
		else -- Not fading sound
			fanPitch = waterTempVolume -- Not fading fan pitch
			if fanPitch > 1.3 then fanPitch = 1.3 end -- Fan pitch max value
			obj:setVolumePitch(rfan, waterTempVolume/2, fanPitch)
		end		
	else -- Fade out sound (when fan is stopping)
		obj:setVolumePitch(rfan, fanVolume/1.5, fanPitch)
		if fanVolume >= 0 then fanVolume = fanVolume - 0.007 end -- If fan volume is not 0 then decrease fan volume slowly
		if fanPitch >= 0 then fanPitch = fanPitch - 0.007 end -- If fan pitch is not 0 then decrease fan volume slowly
	end
--================================================================RADIATOR FAN SOUND================================================================	
	
	
	
	
	
--=========================================================BRAKE SOUND===========================================================
	if isBrakeSquealEnabled == true then -- If sound enabled from the app
		if electrics.values.brake_input > 0.75 and electrics.values.gearIndex > 0 and electrics.values.wheelspeed > 1 then		
		--If brake is pressed more then 75% and not in reverse gear and wheels are not blocked
			brakeFadeIn = brakeFadeIn + dt -- dt = time in seconds
			if brakeFadeIn < 0.7/4 then -- Volume / 4
				obj:setVolume(brake, brakeFadeIn * 4)
			end
			
			brakeDuration = brakeDuration + dt -- Duration of the brake in seconds
			
			if isBrakeRand == false then -- Create a random number between 0 and 3
				randBrake = math.random()+math.random()+math.random()
				isBrakeRand = true
			end			
			
			if brakeDuration > randBrake then -- In the brake duration is higher than the random number
				brakeFadeOut = brakeFadeOut + dt		
				if 1-brakeFadeOut*4 > 0 then 
					obj:setVolume(brake, 1-brakeFadeOut * 4) -- Then fade out and stop the sound
				else
					obj:setVolume(brake, 0)
				end
			else
				brakeFadeOut = 0
			end
			
		else
		
			brakeFadeOut = brakeFadeOut + dt -- Fading out the sound	
			if 0.7/4-brakeFadeOut*4 > 0 then -- Volume / 4 - brakeFadeOut * 4  
				obj:setVolume(brake, 1-brakeFadeOut * 4)
			else
				obj:setVolume(brake, 0)
			end
			brakeFadeIn = 0 -- Reset some values...
			isBrakeRand = false
			brakeDuration = 0
			
		end
	else 
		obj:setVolume(brake, 0) -- If brake disabled with the app then stop the sound
	end	
--=========================================================BRAKE SOUND===========================================================



	
	
end --ONUPDATE CLOSE





--===============BRAKE SQUEAL SOUND=================	
local function toggleBrakeSqueal(value)
	isBrakeSquealEnabled = value
end
--===============BRAKE SQUEAL SOUND=================	



M.toggleBrakeSqueal  = toggleBrakeSqueal
M.friction      	 = friction
M.jsonInit	    	 = jsonInit
M.onUpdate	    	 = onUpdate
M.onReset 			 = onInit
M.updateGFX	    	 = onUpdate

return M